var dashboard = function(templateManager, ScreenService, ZHPromise, General, restEngine, localStorageEngine) {

    /*******************************************
     *                                           *
     *                   GERAL                   *
     *                                           *
     ********************************************/


    var self = this;

    var widgetAtiva;

    self.changeStripe = function() {
        var widget = templateManager.container.getWidget('popUpStripe');
        ScreenService.openPopup(widget);
        var arrayEmpresa = templateManager.container.getWidget('stripe').currentRow.NMEMPRESA.split(" - ");
        var arrayVencimento = templateManager.container.getWidget('stripe').currentRow.DATA.split(" ");
        widget.currentRow.CDEMPRESA = arrayEmpresa[0];
        widget.currentRow.NMEMPRESA = '';
        for (var i = 1; i < arrayEmpresa.length; i++) {
            widget.currentRow.NMEMPRESA = widget.currentRow.NMEMPRESA + ' ' + arrayEmpresa[i];
        }
        widget.currentRow.DATA = {
            "start": arrayVencimento[1],
            "end": arrayVencimento[3]
        };

        widget.reload();
    };

    self.comfirmChangeStripe = function(widget) {
        var widgetStripe = templateManager.container.getWidget('stripe');
        widgetStripe.currentRow = {};
        widgetStripe.currentRow.NMEMPRESA = widget.currentRow.CDEMPRESA + ' - ' + widget.currentRow.NMEMPRESA;
        widgetStripe.currentRow.DATA = 'De ' + widget.currentRow.DATA.start + ' até ' + widget.currentRow.DATA.end;
        ScreenService.closePopup();
        self.setFilter(widget.currentRow.CDEMPRESA, widget.currentRow.DATA, widgetAtiva.name.substring(widgetAtiva.name.length - 3));
        templateManager.container.getWidget(widgetAtiva.name).active = true;
        templateManager.container.getWidget(widgetAtiva.name).activate();
    };

    self.setFilter = function(cdempresa, data, module) {
        switch (module) {
            case "Fin":
                self.setFilterFin(cdempresa, data);
                break;
            case "Fis":
                self.setFilterFis(cdempresa, data);
                break;
        }
    };

    self.openWindow = function(windowName, newWindow) {
        requestModulesMetadata().then(function(modules) {
            var subModule = windowName.split('#')[0];
            var module = subModule.split('_')[0];
            var url = window.location.origin + '/' + modules[module].baseUrl + "/#/" + windowName;
            ScreenService.openLink(url, false);
        });
    };

    var requestModulesMetadata = function() {
        var modulesPackage = window.modulesPackage || "modules";
        return restEngine.requestMetaData(modulesPackage + "#json/modules.json").then(function(response) {
            return response.data;
        });
    };

    self.updateNotificationsValue = function(widget) {
        if (widget.dataSource.data.length > 0) {
            widget.notification = widget.dataSource.data.shift().NRCOUNT;
            /*if(widget.notification == ""){
            }*/
        }
        else {
            widget.notification = "0";
        }
    };

    /*******************************************
     *                                           *
     *           ABA DASHBOARD FINANCEIRO        *
     *                                           *
     ********************************************/

    /**
     * Variaveis de Inicializacao
     */
    var dataSourceA = [];
    var dataSourceB = [];
    var dataSourceC = [];

    self.setMaskContaCorr = function(widget) {
        var data = widget.dataSource.data;
        var contFormatada;
        data.forEach(function(value) {
            var tamanho = value.CDPICTCONT.split("-")[0].length;
            value.CDCONTCORR = value.CDCONTCORR.substring(0, tamanho) + "-" + value.CDCONTCORR.substring(tamanho, value.CDCONTCORR.length + 1);
        });
    };

    /**
     * Define Mascara de CNPJ/CPF de Cliente
     */
    self.setMaskCnpjCpfCliente = function(widget) {
        var data = widget.dataSource.data;
        var inscFormatada;
        data.forEach(function(value) {
            if (value.NRINSJURCLIE.length === 14) inscFormatada = value.NRINSJURCLIE.substr(0, 2) + '.' + value.NRINSJURCLIE.substr(2, 3) + '.' + value.NRINSJURCLIE.substr(5, 3) + '/' + value.NRINSJURCLIE.substr(8, 4) + '-' + value.NRINSJURCLIE.substr(12, 2);
            else if (value.NRINSJURCLIE.length === 11) inscFormatada = value.NRINSJURCLIE.substr(0, 3) + '.' + value.NRINSJURCLIE.substr(3, 3) + '.' + value.NRINSJURCLIE.substr(6, 3) + '-' + value.NRINSJURCLIE.substr(9, 2);
            value.NRINSJURCLIE = inscFormatada ? inscFormatada : value.NRINSJURCLIE;
        });
    };

    /**
     * Define Mascara de CNPJ/CPF de Fornecedor
     */
    self.setMaskCnpjCpfForneced = function(widget) {
        var data = widget.dataSource.data;
        var inscFormatada;
        data.forEach(function(value) {
            if (value.NRINSJURFORN.length === 14) inscFormatada = value.NRINSJURFORN.substr(0, 2) + '.' + value.NRINSJURFORN.substr(2, 3) + '.' + value.NRINSJURFORN.substr(5, 3) + '/' + value.NRINSJURFORN.substr(8, 4) + '-' + value.NRINSJURFORN.substr(12, 2);
            else if (value.NRINSJURFORN.length === 11) inscFormatada = value.NRINSJURFORN.substr(0, 3) + '.' + value.NRINSJURFORN.substr(3, 3) + '.' + value.NRINSJURFORN.substr(6, 3) + '-' + value.NRINSJURFORN.substr(9, 2);
            value.NRINSJURFORN = inscFormatada ? inscFormatada : value.NRINSJURFORN;
        });
    };

    self.setFilterFin = function(cdempresa, data) {
        ScreenService.hideLoader();

        templateManager.container.getWidget('boletReceberVenc').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
            if (filter.name == 'NRORG') {
                filter.value = getLocalVar('NRORG');
            }

        });

        General.callRestEngine('/crud/finpdccont', 'FilterData', templateManager.container.getWidget('boletReceberVenc').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('boletReceberVenc').dataSource.data = sucess.dataset.finpdccont;
                self.updateNotificationsValue(templateManager.container.getWidget('boletReceberVenc'));
            });

        templateManager.container.getWidget('boletReceberAberto').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
            if (filter.name == 'NRORG') {
                filter.value = getLocalVar('NRORG');
            }
        });

        General.callRestEngine('/crud/finpdccont', 'FilterData', templateManager.container.getWidget('boletReceberAberto').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('boletReceberAberto').dataSource.data = sucess.dataset.finpdccont;
                self.updateNotificationsValue(templateManager.container.getWidget('boletReceberAberto'));
            });

        templateManager.container.getWidget('boletReceberBaixa').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
            if (filter.name == 'NRORG') {
                filter.value = getLocalVar('NRORG');
            }
        });

        General.callRestEngine('/crud/finpdccont', 'FilterData', templateManager.container.getWidget('boletReceberBaixa').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('boletReceberBaixa').dataSource.data = sucess.dataset.finpdccont;
                self.updateNotificationsValue(templateManager.container.getWidget('boletReceberBaixa'));
            });

        templateManager.container.getWidget('boletPagarVenc').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
            if (filter.name == 'NRORG') {
                filter.value = getLocalVar('NRORG');
            }
        });

        General.callRestEngine('/crud/finpdccont', 'FilterData', templateManager.container.getWidget('boletPagarVenc').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('boletPagarVenc').dataSource.data = sucess.dataset.finpdccont;
                self.updateNotificationsValue(templateManager.container.getWidget('boletPagarVenc'));
            });

        templateManager.container.getWidget('boletPagarAberto').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
            if (filter.name == 'NRORG') {
                filter.value = getLocalVar('NRORG');
            }
        });

        General.callRestEngine('/crud/finpdccont', 'FilterData', templateManager.container.getWidget('boletPagarAberto').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('boletPagarAberto').dataSource.data = sucess.dataset.finpdccont;
                self.updateNotificationsValue(templateManager.container.getWidget('boletPagarAberto'));
            });

        templateManager.container.getWidget('boletPagarBaixa').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
            if (filter.name == 'NRORG') {
                filter.value = getLocalVar('NRORG');
            }
        });

        General.callRestEngine('/crud/finpdccont', 'FilterData', templateManager.container.getWidget('boletPagarBaixa').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('boletPagarBaixa').dataSource.data = sucess.dataset.finpdccont;
                self.updateNotificationsValue(templateManager.container.getWidget('boletPagarBaixa'));
            });

        templateManager.container.getWidget('widgetTitulosReceber').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
            // Passar para os graficos de Divisão de Receitas e Divisão de Despesas
            // a data do stripe como pameratro 
            if (filter.name == 'P_DTVENBOLRECINI') {
                filter.value = data.start;
            }
            if (filter.name == 'P_DTVENBOLRECFIN') {
                filter.value = data.end;
            }
        });

        General.callRestEngine('/crud/pdctitreceber', 'FilterData', templateManager.container.getWidget('widgetTitulosReceber').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('widgetTitulosReceber').dataSource.data = sucess.dataset.pdctitreceber;
                self.setMaskCnpjCpfCliente(templateManager.container.getWidget('widgetTitulosReceber'));
            });


        templateManager.container.getWidget('widgetTitulosPagar').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
            // Passar para os graficos de Divisão de Receitas e Divisão de Despesas
            // a data do stripe como pameratro 
            if (filter.name == 'P_DTVENBOLPAGINI') {
                filter.value = data.start;
            }
            if (filter.name == 'P_DTVENBOLPAGFIN') {
                filter.value = data.end;
            }
        });

        General.callRestEngine('/crud/pcdtitpagar', 'FilterData', templateManager.container.getWidget('widgetTitulosPagar').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('widgetTitulosPagar').dataSource.data = sucess.dataset.pcdtitpagar;
                self.setMaskCnpjCpfForneced(templateManager.container.getWidget('widgetTitulosPagar'));
            });
        // Passar para os graficos de Divisão de Receitas e Divisão de Despesas
        // a data do stripe como pameratro 
        templateManager.container.getWidget('DONUTRECEITA').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_DTVENBOLRECINI') {
                filter.value = data.start;
            }
            if (filter.name == 'P_DTVENBOLRECFIN') {
                filter.value = data.end;
            }
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }

        });

        General.callRestEngine('/crud/pdcdivisaorec', 'FilterData', templateManager.container.getWidget('DONUTRECEITA').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('DONUTRECEITA').dataSource.data = sucess.dataset.pdcdivisaorec;
            });

        templateManager.container.getWidget('DONUTDESPESAS').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_DTVENBOLPAGINI') {
                filter.value = data.start;
            }
            if (filter.name == 'P_DTVENBOLPAGFIN') {
                filter.value = data.end;
            }
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
        });

        General.callRestEngine('/crud/pdcdivisaopag', 'FilterData', templateManager.container.getWidget('DONUTDESPESAS').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('DONUTDESPESAS').dataSource.data = sucess.dataset.pdcdivisaopag;
            });

        templateManager.container.getWidget('clientInadimplenteWidget').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
        });

        templateManager.container.getWidget('donutClientInadimplente').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
        });

        General.callRestEngine('/crud/pdcclieinadiple', 'FilterData', templateManager.container.getWidget('clientInadimplenteWidget').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('clientInadimplenteWidget').dataSource.data = sucess.dataset.pdcclieinadiple;
                templateManager.container.getWidget('donutClientInadimplente').dataSource.data = sucess.dataset.pdcclieinadiple;
                self.setMaskCnpjCpfCliente(templateManager.container.getWidget('clientInadimplenteWidget'));
            });

        templateManager.container.getWidget('curvaABCWidget').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'CODEMPRESA') {
                filter.value = cdempresa;
            }
            if (filter.name == 'DATVENIN') {
                filter.value = data.start;
            }
            if (filter.name == 'DATVENFIN') {
                filter.value = data.end;
            }
        });

        General.callRestEngine('/crud/curvaabc_dashboard', 'FilterData', templateManager.container.getWidget('curvaABCWidget').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('curvaABCWidget').dataSource.data = sucess.dataset.curvaabc_dashboard;
                self.setABCcurve(templateManager.container.getWidget('curvaABCWidget'));
            });


        templateManager.container.getWidget('saldoWidget').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'CDEMPRESA') {
                filter.value = cdempresa;
            }
        });

        General.callRestEngine('/crud/pdcsaldo', 'FilterData', templateManager.container.getWidget('saldoWidget').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('saldoWidget').dataSource.data = sucess.dataset.pdcsaldo;
                self.setMaskContaCorr(templateManager.container.getWidget('saldoWidget'));
            });

        templateManager.container.getWidget('fluxoCaixa').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'NRORG') {
                filter.value = getLocalVar('NRORG');
            }
            if (filter.name == 'CDEMPRESA') {
                filter.value = cdempresa;
            }
        });

        General.callRestEngine('/crud/pdcfluxo', 'FilterData', templateManager.container.getWidget('fluxoCaixa').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('fluxoCaixa').dataSource.data = sucess.dataset.pdcfluxo;
            });

        var filterEmpresa = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": cdempresa
        }];

        General.callRestEngine('/crud/empresa', 'FilterData', filterEmpresa).then(function(empresa) {
            templateManager.container.getWidget('donutClientInadimplente').labelInfo =
                "Clientes Inadimplentes Empresa: " + empresa.dataset.empresa[0].NMEMPRESA;
            templateManager.container.getWidget('donutCurvaABC').labelInfo =
                "Curva A Empresa: " + empresa.dataset.empresa[0].NMEMPRESA;
            templateManager.container.getWidget('fluxoCaixa').labelInfo =
                "Fluxo de Caixa de TODAS as contas da Empresa " + empresa.dataset.empresa[0].NMEMPRESA;
        });

        ScreenService.hideLoader();

    };

    self.setABCcurve = function(widget) {
        // Função comentada foi feita para alimentar o ultimo grafico do dashboard
        // foi mantida apenas como referencia para futuras necessidades
        //var curvaABCGraph = templateManager.container.getWidget('curvaABCGraph');
        var widgetDonutCurv = templateManager.container.getWidget('donutCurvaABC');
        dataSourceA = [];
        dataSourceB = [];
        dataSourceC = [];
        if (widget.dataSource.data.length > 0) {
            self.setMaskCnpjCpfCliente(widget);
            var percentual = 0;
            //curvaABCGraph.dataSource.data = [];
            widget.dataSource.data.forEach(function(data) {
                if (percentual < data.CURVAA) {
                    percentual = percentual + data.PERC;
                    data.CURVA = 'A';
                    dataSourceA.push(data);
                    //curvaABCGraph.dataSource.data.push(data);
                }
                else if ((percentual > data.CURVAA) || (percentual < data.CURVAB)) {
                    percentual = percentual + data.PERC;
                    data.CURVA = 'B';
                    dataSourceB.push(data);
                    //curvaABCGraph.dataSource.data.push(data);
                }
                else if ((percentual > data.CURVAA) || (percentual > data.CURVAB)) {
                    data.CURVA = 'C';
                    dataSourceC.push(data);
                    //curvaABCGraph.dataSource.data.push(data);
                }
            });
            /*var vrtotal = [];
            var nmRazao = [];
            var dataSourceFin = [];
            var name;
            var value;
            var element;
            var objetoA = {"CURVA" : "A"};
            var objetoB = {"CURVA" : "B"};
            var objetoC = {"CURVA" : "C"};
            curvaABCGraph.dataSource.data.forEach(function(data){
    	        if(data.CURVA == "A"){
                    name = data.NMRAZSOCCLIE.replace(/ /g, "_");
                    value = data.VRTOTCLIE;
	                element = {};
    	            element[name] = value; 
    	            vrtotal.push(name);
    	            nmRazao.push(data.NMRAZSOCCLIE);
    	            Object.assign(objetoA, element);
    	        }
    	        else if(data.CURVA == "B"){
    	            name = data.NMRAZSOCCLIE.replace(/ /g, "_");
                    value = data.VRTOTCLIE;
	                element = {};
    	            element[name] = value; 
    	            vrtotal.push(name);
    	            nmRazao.push(data.NMRAZSOCCLIE);
    	            Object.assign(objetoB, element);
    	        }
    	        else if(data.CURVA == "C"){
    	            name = data.NMRAZSOCCLIE.replace(/ /g, "_");
                    value = data.VRTOTCLIE;
	                element = {};
    	            element[name] = value; 
    	            vrtotal.push(name);
    	            nmRazao.push(data.NMRAZSOCCLIE);
    	            Object.assign(objetoC, element);
    	        }
    	    });
    	    dataSourceFin.push(objetoA);
    	    dataSourceFin.push(objetoB);
    	    dataSourceFin.push(objetoC);
    	    curvaABCGraph.dataSource.data = dataSourceFin;
    	    curvaABCGraph.chartSeries[0].serieFields = vrtotal;
    	    curvaABCGraph.chartSeries[0].serieLabels = nmRazao;
            curvaABCGraph.reload();
            curvaABCGraph.updateChart();*/
            widgetDonutCurv.dataSource.data = dataSourceA;
            widgetDonutCurv.reload();
        }
    };

    self.setStripeDataFin = function(widget) {
        getLocalVar('loginPromise').then(function() {
            widgetAtiva = widget;

            var filterFinAtual;
            var dataIniAtual;
            var dataFinAtual;

            templateManager.container.getWidget('widgetTitulosReceber').dataSourceFilter.forEach(function(filter) {
                if (filter.name == 'P_CDEMPRESA') {
                    filterFinAtual = filter.value;
                }
                if (filter.name == 'P_DTVENBOLRECINI') {
                    dataIniAtual = filter.value;
                }
                if (filter.name == 'P_DTVENBOLRECFIN') {
                    dataFinAtual = filter.value;
                }
            });

            if (filterFinAtual == "") {
                var stripeWidget = templateManager.container.getWidget("stripe");
                var popUpStripe = templateManager.container.getWidget('popUpStripe');

                var filterFilial = [{
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }];

                General.callRestEngine('/crud/filial', 'FilterData', filterFilial).then(function(filial) {
                    var filterEmpresa = [{
                        "name": "CDEMPRESA",
                        "operator": "=",
                        "value": filial.dataset.filial[0].CDEMPRESA
                    }];
                    
                    General.callRestEngine('/crud/empresa', 'FilterData', filterEmpresa).then(function(empresa) {
                        stripeWidget.currentRow = {};
                        stripeWidget.currentRow.NMEMPRESA = empresa.dataset.empresa[0].CDEMPRESA + ' - ' + empresa.dataset.empresa[0].NMEMPRESA;
                        stripeWidget.currentRow.DATA = ScreenService.i18n("De") +' ' + moment().subtract(1, 'months').endOf("month").format('DD/MM/YYYY') + ' ' + ScreenService.i18n("até")+ ' ' + moment().format('DD/MM/YYYY');
                        var data = {
                            "start": moment().subtract(1, 'months').format('DD/MM/YYYY'),
                            "end": moment().format('DD/MM/YYYY')
                        };
                        templateManager.container.getWidget('widgetDashboardFin').active = true;
                        templateManager.container.getWidget('widgetDashboardFin').activate();
                        popUpStripe.currentRow.CDEMPRESA = empresa.dataset.empresa[0].CDEMPRESA;
                        popUpStripe.currentRow.NMEMPRESA = empresa.dataset.empresa[0].NMEMPRESA;
                        popUpStripe.currentRow.DATA = data;
                        popUpStripe.currentRow.NRINSJUREMPR = empresa.dataset.empresa[0].NRINSJUREMPR;
                        self.setFilterFin(empresa.dataset.empresa[0].CDEMPRESA, data);
                    });
                });
            }
            else {
                var arrayEmpresa = templateManager.container.getWidget('stripe').currentRow.NMEMPRESA.split(" - ");
                var arrayVencimento = templateManager.container.getWidget('stripe').currentRow.DATA.split(" ");
                var cdempresa = arrayEmpresa[0];
                var data = {
                    "start": arrayVencimento[1],
                    "end": arrayVencimento[3]
                };
                if ((filterFinAtual != cdempresa) || (dataIniAtual != data.start) || (dataFinAtual != data.end)) {
                    self.setFilter(cdempresa, data, widgetAtiva.name.substring(widgetAtiva.name.length - 3));
                }
            }
        });
    };

    self.openTilutoRecClientInadim = function() {
        var widget = templateManager.container.getWidget('clientInadimplenteWidget');

        var dataMax = widget.dataSource.data[0].DTVENBOLRECMAX,
            dataMin = widget.dataSource.data[0].DTVENBOLRECMIN,
            date1, date2;
        widget.dataSource.data.forEach(function(element) {
            if (element.DTVENBOLRECMAX) {
                date1 = new Date(moment(element.DTVENBOLRECMAX, "DD/MM/YYYY").format("MM/DD/YYYY"));
                date2 = new Date(moment(dataMax, "DD/MM/YYYY").format("MM/DD/YYYY"));
                if (date1.getTime() > date2.getTime()) {
                    dataMax = element.DTVENBOLRECMAX;
                }
            }
            if (element.DTVENBOLRECMIN) {
                date1 = new Date(moment(element.DTVENBOLRECMIN, "DD/MM/YYYY").format("MM/DD/YYYY"));
                date2 = new Date(moment(dataMin, "DD/MM/YYYY").format("MM/DD/YYYY"));
                if (date1.getTime() < date2.getTime()) {
                    dataMin = element.DTVENBOLRECMIN;
                }
            }
        });

        sessionStorage.setItem('DTVENBOLREC.start', dataMin);
        sessionStorage.setItem('DTVENBOLREC.end', dataMax);
        sessionStorage.setItem('DASHBOARD_NAME', widget.name);
        sessionStorage.setItem('CDEMPRESA', widget.dataSource.data[0].CDEMPRESA);
        sessionStorage.setItem('NMEMPRESA', widget.dataSource.data[0].NMEMPRESA);
        self.openWindow('fin_contaReceber#rec00001_titulos_a_receber');
    };

    self.openTilutoRecClient = function() {
        var widget = templateManager.container.getWidget('widgetTitulosReceber');

        var tamanho = widget.dataSource.data.length;

        sessionStorage.setItem('DTVENBOLREC.start', widget.dataSource.data[0].DTVENBOLREC);
        sessionStorage.setItem('DTVENBOLREC.end', widget.dataSource.data[(tamanho - 1)].DTVENBOLREC);
        sessionStorage.setItem('DASHBOARD_NAME', widget.name);
        sessionStorage.setItem('CDEMPRESA', widget.dataSource.data[0].CDEMPRESA);
        sessionStorage.setItem('NMEMPRESA', widget.dataSource.data[0].NMEMPRESA);
        self.openWindow('fin_contaReceber#rec00001_titulos_a_receber');
    };

    self.openTilutoPag = function() {
        var widget = templateManager.container.getWidget('widgetTitulosPagar');

        var tamanho = widget.dataSource.data.length;

        sessionStorage.setItem('DTVENBOLPAG.start', widget.dataSource.data[0].DTVENBOLPAG);
        sessionStorage.setItem('DTVENBOLPAG.end', widget.dataSource.data[(tamanho - 1)].DTVENBOLPAG);
        sessionStorage.setItem('DASHBOARD_NAME', widget.name);
        sessionStorage.setItem('CDEMPRESA', widget.dataSource.data[0].CDEMPRESA);
        sessionStorage.setItem('NMEMPRESA', widget.dataSource.data[0].NMEMPRESA);
        self.openWindow('fin_contaPagar#pag00001_titulos_a_pagar');
    };

    self.changeCurv = function(widget) {
        if (widget.tipoVisualizacao == "A") {
            if (dataSourceB.length > 0) {
                widget.dataSource.data = dataSourceB;
                widget.label = "Curva B";
                widget.tipoVisualizacao = "B";
                widget.labelInfo = widget.labelInfo.replace("Curva A", "Curva B");
                widget.reload();
                widget.updateChart();
            }
        }
        else if (widget.tipoVisualizacao == "B") {
            if (dataSourceC.length > 0) {
                widget.dataSource.data = dataSourceC;
                widget.label = "Curva C";
                widget.tipoVisualizacao = "C";
                widget.labelInfo.replace("Curva B", "Curva C");
                widget.reload();
                widget.updateChart();
            }
            else {
                widget.tipoVisualizacao = "C";
                widget.labelInfo = widget.labelInfo.replace("Curva B", "Curva C");
                self.changeCurv(widget);
            }
        }
        else if (widget.tipoVisualizacao == "C") {
            widget.dataSource.data = dataSourceA;
            widget.label = "Curva A";
            widget.tipoVisualizacao = "A";
            widget.labelInfo = widget.labelInfo.replace("Curva C", "Curva A");
            widget.reload();
            widget.updateChart();
        }
    };

    self.openTilutoPagBoletos = function(widget) {
        var stripeWidget = templateManager.container.getWidget("stripe");

        if (widget.notification > 0) {
            var dtInicial = moment().format("DD/MM/YYYY");
            var dtFinal = moment().format("DD/MM/YYYY");
            var IDSTATBPAG;
            widget.dataSourceFilter.forEach(function(filter) {
                if (filter.name == 'P_ID') {
                    if (filter.value == 'VENCIDO') {
                        IDSTATBPAG = "A,E";
                        dtInicial = "01/01/1999";
                    }
                    if (filter.value == 'ABERTO_DIA') {
                        IDSTATBPAG = "A";
                    }
                    if (filter.value == 'BAIXADO_DIA') {
                        IDSTATBPAG = "B";
                    }
                }

                var arrayEmpresa = templateManager.container.getWidget('stripe').currentRow.NMEMPRESA.split(" - ");
                var arrayVencimento = templateManager.container.getWidget('stripe').currentRow.DATA.split(" ");
                var CDEMPRESA = arrayEmpresa[0];
                var NMEMPRESA = '';
                for (var i = 1; i < arrayEmpresa.length; i++) {
                    NMEMPRESA = NMEMPRESA + ' ' + arrayEmpresa[i];
                }
                sessionStorage.setItem('DTVENBOLPAG.start', dtInicial);
                sessionStorage.setItem('DTVENBOLPAG.end', dtFinal);
                sessionStorage.setItem('DASHBOARD_NAME', widget.name);
                sessionStorage.setItem('CDEMPRESA', CDEMPRESA);
                sessionStorage.setItem('NMEMPRESA', NMEMPRESA);
                sessionStorage.setItem('IDSTATBPAG', IDSTATBPAG);
                self.openWindow('fin_contaPagar#pag00001_titulos_a_pagar');
            });
        }
    };

    self.openTilutoRecBoletos = function(widget) {
        var stripeWidget = templateManager.container.getWidget("stripe");

        if (widget.notification > 0) {
            var dtInicial = moment().format("DD/MM/YYYY");
            var dtFinal = moment().format("DD/MM/YYYY");
            var IDSTATBREC;
            widget.dataSourceFilter.forEach(function(filter) {
                if (filter.name == 'P_ID') {
                    if (filter.value == 'VENCIDO') {
                        IDSTATBREC = "A,E";
                        dtInicial = "01/01/1999";
                    }
                    else if (filter.value == 'ABERTO_DIA') {
                        IDSTATBREC = "A";
                    }
                    else if (filter.value == 'BAIXADO_DIA') {
                        IDSTATBREC = "B";
                    }
                }
                var arrayEmpresa = templateManager.container.getWidget('stripe').currentRow.NMEMPRESA.split(" - ");
                var arrayVencimento = templateManager.container.getWidget('stripe').currentRow.DATA.split(" ");
                var CDEMPRESA = arrayEmpresa[0];
                var NMEMPRESA = '';
                for (var i = 1; i < arrayEmpresa.length; i++) {
                    NMEMPRESA = NMEMPRESA + ' ' + arrayEmpresa[i];
                }
                sessionStorage.setItem('DTVENBOLREC.start', dtInicial);
                sessionStorage.setItem('DTVENBOLREC.end', dtFinal);
                sessionStorage.setItem('DASHBOARD_NAME', widget.name);
                sessionStorage.setItem('CDEMPRESA', CDEMPRESA);
                sessionStorage.setItem('NMEMPRESA', NMEMPRESA);
                sessionStorage.setItem('IDSTATBREC', IDSTATBREC);
                self.openWindow('fin_contaReceber#rec00001_titulos_a_receber');
            });
        }
    };

    /*******************************************
     *                                           *
     *           ABA DASHBOARD FISCAL            *
     *                                           *
     ********************************************/

    self.setStripeDataFis = function(widget) {
        widgetAtiva = widget;

        var filterFisAtual;
        var dataIniAtual;
        var dataFinAtual;

        templateManager.container.getWidget('fechCupomPendente').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filterFisAtual = filter.value;
            }
            if (filter.name == 'P_DTINICIAL') {
                dataIniAtual = filter.value;
            }
            if (filter.name == 'P_DTFINAL') {
                dataFinAtual = filter.value;
            }
        });

        if (filterFisAtual == "") {
            var stripeWidget = templateManager.container.getWidget("stripe");
            var popUpStripe = templateManager.container.getWidget('popUpStripe');

            var filterFilial = [{
                "name": "CDFILIAL",
                "operator": "=",
                "value": "FILIAL_LOGADA"
            }];

            General.callRestEngine('/crud/filial', 'FilterData', filterFilial).then(function(filial) {
                var filterEmpresa = [{
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": filial.dataset.filial[0].CDEMPRESA
                }];
                General.callRestEngine('/crud/empresa', 'FilterData', filterEmpresa).then(function(empresa) {
                    stripeWidget.currentRow = {};
                    stripeWidget.currentRow.NMEMPRESA = empresa.dataset.empresa[0].CDEMPRESA + ' - ' + empresa.dataset.empresa[0].NMEMPRESA;
                    stripeWidget.currentRow.DATA = 'De ' + moment().subtract(1, 'months').format('DD/MM/YYYY') + ' até ' + moment().format('DD/MM/YYYY');
                    var data = {
                        "start": moment().subtract(1, 'months').format('DD/MM/YYYY'),
                        "end": moment().format('DD/MM/YYYY')
                    };
                    templateManager.container.getWidget('widgetDashboardFis').active = true;
                    templateManager.container.getWidget('widgetDashboardFis').activate();
                    popUpStripe.currentRow.CDEMPRESA = empresa.dataset.empresa[0].CDEMPRESA;
                    popUpStripe.currentRow.NMEMPRESA = empresa.dataset.empresa[0].NMEMPRESA;
                    popUpStripe.currentRow.DATA = data;
                    popUpStripe.currentRow.NRINSJUREMPR = empresa.dataset.empresa[0].NRINSJUREMPR;
                    self.setFilterFis(empresa.dataset.empresa[0].CDEMPRESA, data);
                });
            });
        }
        else {
            var arrayEmpresa = templateManager.container.getWidget('stripe').currentRow.NMEMPRESA.split(" - ");
            var arrayVencimento = templateManager.container.getWidget('stripe').currentRow.DATA.split(" ");
            var cdempresa = arrayEmpresa[0];
            var data = {
                "start": arrayVencimento[1],
                "end": arrayVencimento[3]
            };
            if ((filterFisAtual != cdempresa) || (dataIniAtual != data.start) || (dataFinAtual != data.end)) {
                self.setFilter(cdempresa, data, widgetAtiva.name.substring(widgetAtiva.name.length - 3));
            }
        }
    };

    self.setFilterFis = function(cdempresa, data) {
        templateManager.container.getWidget('fechCupomPendente').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
            if (filter.name == 'P_DTINICIAL') {
                filter.value = data.start;
            }
            if (filter.name == 'P_DTFINAL') {
                filter.value = data.end;
            }
            if (filter.name == 'NRORG') {
                filter.value = getLocalVar('NRORG');
            }
        });

        General.callRestEngine('/crud/fispdccont', 'FilterData', templateManager.container.getWidget('fechCupomPendente').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('fechCupomPendente').dataSource.data = sucess.dataset.fispdccont;
                self.updateNotificationsValue(templateManager.container.getWidget('fechCupomPendente'));
            });


        templateManager.container.getWidget('notaFiscalPendente').dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
            if (filter.name == 'P_DTINICIAL') {
                filter.value = data.start;
            }
            if (filter.name == 'P_DTFINAL') {
                filter.value = data.end;
            }
            if (filter.name == 'NRORG') {
                filter.value = getLocalVar('NRORG');
            }
        });

        General.callRestEngine('/crud/fispdccont', 'FilterData', templateManager.container.getWidget('notaFiscalPendente').dataSourceFilter).then(
            function(sucess) {
                templateManager.container.getWidget('notaFiscalPendente').dataSource.data = sucess.dataset.fispdccont;
                self.updateNotificationsValue(templateManager.container.getWidget('notaFiscalPendente'));
            });

        if (templateManager.container.getWidget('detImposto').chartXAxisField == 'NMIMPOSTO') {
            self.trocarGraficoDetalhamentoImposto(templateManager.container.getWidget('detImposto'));
            templateManager.container.getWidget('detImposto').dataSourceFilter.forEach(function(filter) {
                if (filter.name == 'CDEMPRESA') {
                    filter.value = cdempresa;
                }
                if (filter.name == 'DTINICIAL') {
                    filter.value = moment(data.end, 'DD/MM/YYYY').subtract(1, 'years').format('DD/MM/YYYY');
                }
                if (filter.name == 'DTFINAL') {
                    filter.value = data.end;
                }
                if (filter.name == 'NRORG') {
                    filter.value = getLocalVar('NRORG');
                }
            });

            General.callRestEngine('/crud/detalhamento_imposto_mes', 'FilterData', templateManager.container.getWidget('detImposto').dataSourceFilter).then(
                function(sucess) {
                    templateManager.container.getWidget('detImposto').dataSource.data = sucess.dataset.detalhamento_imposto;
                });
        }
        else {
            templateManager.container.getWidget('detImposto').dataSourceFilter.forEach(function(filter) {
                if (filter.name == 'CDEMPRESA') {
                    filter.value = cdempresa;
                }
                if (filter.name == 'DTINICIAL') {
                    filter.value = moment(data.end, 'DD/MM/YYYY').subtract(1, 'years').format('DD/MM/YYYY');
                }
                if (filter.name == 'DTFINAL') {
                    filter.value = data.end;
                }
                if (filter.name == 'NRORG') {
                    filter.value = getLocalVar('NRORG');
                }
            });

            General.callRestEngine('/crud/detalhamento_imposto', 'FilterData', templateManager.container.getWidget('detImposto').dataSourceFilter).then(
                function(sucess) {
                    templateManager.container.getWidget('detImposto').dataSource.data = sucess.dataset.detalhamento_imposto;
                });
        }

    };

    self.openFechamentoPendente = function() {
        var widget = templateManager.container.getWidget('fechCupomPendente');

        widget.dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                sessionStorage.setItem('P_CDEMPRESA', filter.value);
            }
            if (filter.name == 'P_DTINICIAL') {
                sessionStorage.setItem('P_DTINICIAL', filter.value);
            }
            if (filter.name == 'P_DTFINAL') {
                sessionStorage.setItem('P_DTFINAL', filter.value);
            }
            if (filter.name == 'P_IDAPROVACAONFCE') {
                sessionStorage.setItem('P_IDAPROVACAONFCE', filter.value);
            }
        });

        self.openWindow('product#dashboard_fechCupomPendente');
    };

    self.openNotasFiscais = function() {
        var widget = templateManager.container.getWidget('fechCupomPendente');

        widget.dataSourceFilter.forEach(function(filter) {
            if (filter.name == 'P_CDEMPRESA') {
                sessionStorage.setItem('P_CDEMPRESA', filter.value);
            }
            if (filter.name == 'P_DTINICIAL') {
                sessionStorage.setItem('P_DTINICIAL', filter.value);
            }
            if (filter.name == 'P_DTFINAL') {
                sessionStorage.setItem('P_DTFINAL', filter.value);
            }
            if (filter.name == 'P_IDAPROVACAONFCE') {
                sessionStorage.setItem('P_IDAPROVACAONFCE', filter.value);
            }
        });

        self.openWindow('product#dashboard_notasFiscais');
    };

    this.trocarGraficoDetalhamentoImposto = function(widget) {

        if (widget.chartXAxisField == 'MES') {
            templateManager.container.getWidget('detImposto').dataSourceFilter.forEach(function(filter) {
                if (filter.name == 'CDEMPRESA') {
                    filter.value = widget.currentRow.CDEMPRESA;
                }
                if (filter.name == 'DTINICIAL') {
                    filter.value = widget.currentRow.DTINIPERIODO;
                }
                if (filter.name == 'DTFINAL') {
                    filter.value = widget.currentRow.DTFIMPERIODO;
                }
                if (filter.name == 'NRORG') {
                    filter.value = getLocalVar('NRORG');
                }
            });

            General.callRestEngine('/crud/detalhamento_imposto_mes', 'FilterData', templateManager.container.getWidget('detImposto').dataSourceFilter).then(
                function(sucess) {
                    templateManager.container.getWidget('detImposto').dataSource.data = sucess.dataset.detalhamento_imposto_mes;
                    widget.chartSeries[0].serieFields = "SOMAIMPOSTOS";
                    widget.chartXAxisField = "NMIMPOSTO";
                    widget.labelInfo = "Detalhamento do mês";
                    templateManager.container.getWidget('detImposto').redraw();
                    templateManager.container.getWidget('detImposto').updateChart();
                },
                function(error) {
                    ScreenService.showMenssage(error);
                });

            //templateManager.container.getWidget('detImposto').reload();
        }
        else if (widget.chartXAxisField == 'NMIMPOSTO') {
            var popUpStripe = templateManager.container.getWidget('popUpStripe');
            var data = {
                "start": moment().subtract(1, 'months').format('DD/MM/YYYY'),
                "end": moment().format('DD/MM/YYYY')
            };
            popUpStripe.currentRow.DATA = data;
            templateManager.container.getWidget('detImposto').dataSourceFilter.forEach(function(filter) {
                if (filter.name == 'CDEMPRESA') {
                    filter.value = widget.currentRow.CDEMPRESA;
                }
                if (filter.name == 'DTINICIAL') {
                    filter.value = moment(data.end, 'DD/MM/YYYY').subtract(1, 'years').format('DD/MM/YYYY');
                }
                if (filter.name == 'DTFINAL') {
                    filter.value = data.end;
                }
                if (filter.name == 'NRORG') {
                    filter.value = getLocalVar('NRORG');
                }
            });

            General.callRestEngine('/crud/detalhamento_imposto', 'FilterData', templateManager.container.getWidget('detImposto').dataSourceFilter).then(
                function(sucess) {
                    templateManager.container.getWidget('detImposto').dataSource.data = sucess.dataset.detalhamento_imposto;
                    widget.labelInfo = "Detalhamento dos Impostos nos Últimos 12 Meses";
                    widget.chartXAxisField = "MES";
                    widget.chartSeries[0].serieFields = "IMPOSTO";
                    templateManager.container.getWidget('detImposto').redraw();
                    templateManager.container.getWidget('detImposto').updateChart();
                });
        }
        else {
            ScreenService.showMenssage("Erro ao carregar dados.");
        }
    };

    /*******************************************
     *                                           *
     *     Tela Fechamento de Cupons Pendentes   *
     *                                           *
     ********************************************/

    self.setDataSourceFechCupomPendente = function() {
        var widget = templateManager.container.getWidget('dashboard_fechCupomPendente');

        widget.dataSourceFilter = [{
                'name': 'NRORG',
                'operator': '=',
                'value': getLocalVar('NRORG')
            },
            {
                'name': 'P_CDEMPRESA',
                'operator': '=',
                'value': sessionStorage.getItem('P_CDEMPRESA')
            },
            {
                'name': 'P_DTINICIAL',
                'operator': '=',
                'value': sessionStorage.getItem('P_DTINICIAL')
            },
            {
                'name': 'P_DTFINAL',
                'operator': '=',
                'value': sessionStorage.getItem('P_DTFINAL')
            },
            {
                'name': 'P_IDAPROVACAONFCE',
                'operator': '=',
                'value': sessionStorage.getItem('P_IDAPROVACAONFCE')
            }
        ];
        widget.reload();

    };

    /*********************************************
     *                                           *
     *     Aba Documentos Fiscais                *
     *                                           *
     *********************************************/



    this.openManifestacaoDestinatario = function(widget) {
        var popUpStripe = templateManager.container.getWidget('popUpStripe');
        var data = JSON.stringify(popUpStripe.currentRow.DATA);
        sessionStorage.setItem('SINCRONIZACAO', "3");
        sessionStorage.setItem('CDEMPRESA', popUpStripe.currentRow.CDEMPRESA);
        sessionStorage.setItem('NMEMPRESA', popUpStripe.currentRow.NMEMPRESA);
        sessionStorage.setItem('DTEMISSAO', data);
        sessionStorage.setItem('NRINSJURIEST', popUpStripe.currentRow.NRINSJURIEST);
        self.openWindow('df_entrada#dfe58000_manifestacao_destinatario');
    };

    this.openAprocacaoLancamento = function(widget) {
        var popUpStripe = templateManager.container.getWidget('popUpStripe');
        var arrayVencimento = templateManager.container.getWidget('stripe').currentRow.DATA.split(" ");
        var data = {
            "start": arrayVencimento[1],
            "end": arrayVencimento[3]
        };
        data = JSON.stringify(data);
        sessionStorage.setItem('IDAPROVACAO', "1");
        sessionStorage.setItem('IDENTRSAIDOP', "E");
        sessionStorage.setItem('CDEMPRESA', popUpStripe.currentRow.CDEMPRESA);
        sessionStorage.setItem('NMEMPRESA', popUpStripe.currentRow.NMEMPRESA);
        sessionStorage.setItem('DTEMISSAO', data);
        self.openWindow('df#dfs56000_aprovacao_lancamentos');
    };

    this.openLiberacaoFin = function(widget) {
        var popUpStripe = templateManager.container.getWidget('popUpStripe');
        var arrayVencimento = templateManager.container.getWidget('stripe').currentRow.DATA.split(" ");
        var data = {
            "start": arrayVencimento[1],
            "end": arrayVencimento[3]
        };
        data = JSON.stringify(data);
        sessionStorage.setItem('CDEMPRESA', popUpStripe.currentRow.CDEMPRESA);
        sessionStorage.setItem('DTEMISSAO', data);
        sessionStorage.setItem('NMEMPRESA', popUpStripe.currentRow.NMEMPRESA);
        self.openWindow('df_entrada#dfe47000_liberacao_para_financeiro');
    };

    this.QtNotasPendente = function(popUpStripe) {
        var arrayVencimento = templateManager.container.getWidget('stripe').currentRow.DATA.split(" ");
        var data = {
            "start": arrayVencimento[1],
            "end": arrayVencimento[3]
        };
        var filter = [{
                'name': 'P_NRINSJUREMPR',
                'operator': '=',
                'value': popUpStripe.currentRow.NRINSJUREMPR
            },
            {
                'name': 'P_DTEMISSAOINI',
                'operator': '=',
                'value': data.start
            },
            {
                'name': 'P_DTEMISSAOFIN',
                'operator': '=',
                'value': data.end
            }
        ];
        General.callRestEngine('/crud/QtNotasPendente', 'FilterData', filter).then(
            function(sucess) {
                if (sucess.dataset.QtNotasPendente.length > 0) {
                    templateManager.container.getWidget("NFPendentes").notification = sucess.dataset.QtNotasPendente[0].QTNOTAS;
                    popUpStripe.currentRow.NRINSJURIEST = sucess.dataset.QtNotasPendente[0].NRINSJURIEST;
                }
                else {
                    templateManager.container.getWidget("NFPendentes").notification = "0";
                    popUpStripe.currentRow.NRINSJURIEST = "";
                }
            });
    };

    this.QtNotasAprovacao = function(popUpStripe) {
        var arrayVencimento = templateManager.container.getWidget('stripe').currentRow.DATA.split(" ");
        var data = {
            "start": arrayVencimento[1],
            "end": arrayVencimento[3]
        };
        var filter = [{
                'name': 'P_CDEMPRESA',
                'operator': '=',
                'value': popUpStripe.currentRow.CDEMPRESA
            },
            {
                'name': 'P_DTENTRSAIDINI',
                'operator': '=',
                'value': data.start
            },
            {
                'name': 'P_DTENTRSAIDFIN',
                'operator': '=',
                'value': data.end
            },
            {
                'name': 'P_NRORG',
                'operator': '=',
                'value': getLocalVar('NRORG')
            }
        ];

        General.callRestEngine('/crud/QtNotasAprovacao', 'FilterData', filter).then(
            function(sucess) {
                if (sucess.dataset.QtNotasAprovacao.length > 0) {
                    templateManager.container.getWidget("NFAprovacao").notification = sucess.dataset.QtNotasAprovacao[0].QTNOTAS;
                }
                else {
                    templateManager.container.getWidget("NFAprovacao").notification = "0";
                }
            });

    };

    this.QtNotasLiberacaoFin = function(popUpStripe) {
        var arrayVencimento = templateManager.container.getWidget('stripe').currentRow.DATA.split(" ");
        var data = {
            "start": arrayVencimento[1],
            "end": arrayVencimento[3]
        };
        var filter = [{
                'name': 'P_CDEMPRESA',
                'operator': '=',
                'value': popUpStripe.currentRow.CDEMPRESA
            },
            {
                'name': 'P_DTENTRSAIDINI',
                'operator': '=',
                'value': data.start
            },
            {
                'name': 'P_DTENTRSAIDFIN',
                'operator': '=',
                'value': data.end
            }
        ];

        General.callRestEngine('/crud/QtNotasLiberacaoFin', 'FilterData', filter).then(
            function(sucess) {
                if (sucess.dataset.QtNotasLiberacaoFin.length > 0) {
                    templateManager.container.getWidget("NFLiberacaoFin").notification = sucess.dataset.QtNotasLiberacaoFin[0].QTNOTAS;
                }
                else {
                    templateManager.container.getWidget("NFLiberacaoFin").notification = "0";
                }
            });

    };

    this.QtNotasSemAf = function(popUpStripe) {
        var arrayVencimento = templateManager.container.getWidget('stripe').currentRow.DATA.split(" ");
        var data = {
            "start": arrayVencimento[1],
            "end": arrayVencimento[3]
        };
        var filter = [{
                'name': 'P_CDEMPRESA',
                'operator': '=',
                'value': popUpStripe.currentRow.CDEMPRESA
            },
            {
                'name': 'P_DTEMISSAOINI',
                'operator': '=',
                'value': data.start
            },
            {
                'name': 'P_DTEMISSAOFIN',
                'operator': '=',
                'value': data.end
            },
            {
                'name': 'P_NRORG',
                'operator': '=',
                'value': getLocalVar('NRORG')
            }
        ];

        General.callRestEngine('/crud/QtNotasSemAf', 'FilterData', filter).then(
            function(sucess) {
                if (sucess.dataset.QtNotasSemAf.length > 0) {
                    templateManager.container.getWidget("NFSEMAF").notification = sucess.dataset.QtNotasSemAf[0].QTNOTAS;
                }
                else {
                    templateManager.container.getWidget("NFSEMAF").notification = "0";
                }
            });

    };

    this.setNotificatioDF = function() {
        var popUpStripe = templateManager.container.getWidget('popUpStripe');

        this.QtNotasPendente(popUpStripe);
        this.QtNotasAprovacao(popUpStripe);
        this.QtNotasLiberacaoFin(popUpStripe);
        this.QtNotasSemAf(popUpStripe);

    };

    /*********************************************
     *                                           *
     *                Aba Pedidos                *
     *                                           *
     *********************************************/

    this.setDataPed = function(tela) {
        var container = templateManager.container;
        var filterFilial = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": "FILIAL_LOGADA"
        }];
        General.callRestEngine('/crud/filial', 'FilterData', filterFilial).then(function(filial) {
            var arrayEmpresa = templateManager.container.getWidget('stripe').currentRow.NMEMPRESA.split(" - ");
            var arrayVencimento = templateManager.container.getWidget('stripe').currentRow.DATA.split(" ");
            var cdempresa = arrayEmpresa[0];
            var data = {
                "start": arrayVencimento[1],
                "end": arrayVencimento[3]
            };
            var filter = [{
                    "name": "P_CDFILIAL",
                    "operator": "=",
                    "value": filial.dataset.filial[0].CDFILIAL
                },
                {
                    "name": "P_DTSAIDAINI",
                    "operator": "=",
                    "value": data.start
                },
                {
                    "name": "P_DTSAIDAFIN",
                    "operator": "=",
                    "value": data.end
                }
            ];
            General.callRestEngine('ped#/crud/dashboard_produto', 'FilterData', filter).then(function(data) {
                templateManager.container.getWidget('produtosVendidos').dataSource.data = data.dataset.dashboard_produto;
            });

            var filterRentabilidade = [{
                    "name": "P_CDFILIAL",
                    "operator": "=",
                    "value": filial.dataset.filial[0].CDFILIAL
                },
                {
                    "name": "P_DATAINI",
                    "operator": "=",
                    "value": data.start
                },
                {
                    "name": "P_DATAFIM",
                    "operator": "=",
                    "value": data.end
                },
                {
                    "name": "P_TIPOCUSTO",
                    "operator": "=",
                    "value": '1'
                }
            ];
            General.callRestEngine('ped#/crud/dashboard_rentabilidade', 'FilterData', filterRentabilidade).then(function(data) {
                templateManager.container.getWidget('rentabilidadeProduto').dataSource.data = data.dataset.dashboard_rentabilidade;
            });
        });
    };

    this.openLancPedidos = function(tela) {
        self.openWindow(tela);
        // ScreenService.openWindow(tela);
    };

    this.getLocalVar = function(key) {
        return localStorageEngine.getLocalVar(key);
    };

    this.setLocalVar = function(key, value) {
        localStorageEngine.setLocalVar(key, value);
    };

};

/* global Configuration */
Configuration(function(ContextRegister) {
    ContextRegister.register('dashboard', dashboard);
});
